///////    lowercase.C    /////// 
#include        <iostream>
#include        <fstream>
#include        <stdlib.h>
#include        <ctype.h>

char lower(char c)
{   if ( isupper(c) )
        return tolower(c);
    else return c;
}

void doio(istream& in, ostream& out)
{   char c;
    while (in.get(c))
        out.put( lower(c) );
    out.flush();
}

int main (int argc,  char* argv[])
{   if ( argc == 1 )      // use standard I/O
        doio(std::cin, std::cout);
    else if ( argc == 3 ) // use files given
    {   ifstream infile(argv[1]);
        if ( infile.fail() )
        {   std::cerr << argv[0] << ":can't open input file "
                 << argv[1] << std::endl;
            exit(1);
        }
        ofstream ofile(argv[2]);
        if ( ofile.fail() )
        {   std::cerr << argv[0] << ":can't open output file " 
                 << argv[2] << std::endl;
            exit(1);
        }
        doio(infile, ofile);
    }
    else   // error
    {   std::cerr << "Usage: lower infile outfile" << std::endl;
        exit(1);
    }
    return 0;
}
///////   End of lowercase.C  ///////
