//////    WordCount.C    //////
#include <iostream>
#include "WordCount.h"
using std::cin;                    // namespace declaration

bool WordCount::readin()           // obtain input from cin
{  char c;
   while ( ! buf->isFull() )       // while circular buffer not full
        if ( cin.get(c) )
             buf->produce(c);      // deposit into buffer
        else
             return false;         // input closed
   return true;                    // buffer full
}

void WordCount::count()            // count number of words
{  int c;
   while ( ! buf->isEmpty() )      // while buffer not empty
      switch( c = buf->consume() ) // remove one character from buffer
      {  case ' ' :
         case '\t':
         case '\n':                // word delimiters
              if ( word ) wcnt++;  // word complete
              word = false;        // partial word indicator false
              break;
         default:
              word = true;         // partial word indicator true
      }
}         

