#ifndef __WordCount_SEEN__
#define  __WordCount_SEEN__
//////    WordCount.h    //////
#include "Cirbuf.h"    // use circular buffer

class WordCount
{ public:
    WordCount()
    { buf = new Cirbuf(128);
      wcnt = 0;
      word = false;
    }
    ~WordCount() { delete buf; }
    bool readin();   // obtain input from cin
    void count();    // count number of words
    int getCount() { return wcnt; }
  private:
    int wcnt;        // word count
    bool word;       // partial word indicator
    Cirbuf* buf;     // input buffer
};
#endif
