#ifndef __Fraction_SEEN__
#define  __Fraction_SEEN__
///////    Fraction.h    ///////
#include <iostream>

class Fraction
{  public:
     Fraction() { }  // default constructor
     // constructor, d is not zero
     Fraction(int n, int d);
     void display()
     {   std::cout << num << "/" << denom;
     }
     bool operator==(Fraction& y)
     {   return( num == y.num && denom == y.denom );
     }
     Fraction operator+  (Fraction& y);
     Fraction operator-  ();  // unary negation
     Fraction operator-  (Fraction& y);
     Fraction operator*  (Fraction& y);
     Fraction operator/  (Fraction& y);
     bool operator>  (Fraction& y);
     bool operator<  (Fraction& y);
     bool operator>= (Fraction& y);
     bool operator<= (Fraction& y);
     bool isZero() { return(denom == 1 && num == 0); }
     bool isOne()  { return(denom == 1 && num == 1); }
     bool isInt()  { return(denom == 1); }
     int floor();
     int ceiling();
   private:
     Fraction makeFraction(int n, unsigned d)
     {   Fraction ans;
         ans.num = n; ans.denom = d;
         return ans;
     }
     int num;             // numerator
     unsigned int denom;  // denominator
};
#endif

