///////    Application of functional argument    ///////
#include <iostream>
using std::cout;  using std::endl;

typedef bool (* END_FN)(void *, int);
typedef bool (* BOOLEAN_FN) (void *any, int index);

bool or_test(void *any, BOOLEAN_FN test, END_FN is_end)
{   int len=0;
    while ( ! is_end(any,len) )
    {    if ( test(any, len) ) return true;
         len++;
    }
    return false;
}

bool even(int *ip, int j)
{   return( (ip[j] & 01)  == 0 );}

bool odd(int *ip, int j)
{   return( (ip[j] & 01)  == 1 );}

bool int_end(int *a, int i)
{   return( a[i] == -1 );   }

int str_end(char *a, int i)
{   return( a[i] == '\0' ); }


bool and_test(void *any, BOOLEAN_FN test, END_FN isEnd)
{   int len=0;
    while ( ! isEnd(any, len) )
    {   if ( test(any, len) == 0 ) return false;
        len++;
    }
    return true;
}

int main()
{  int b[]={4,2,8,3,-1};
   int c[]={3,7,1,10,-1};
   int i = or_test(b, reinterpret_cast< BOOLEAN_FN >(even),
                      reinterpret_cast< END_FN >(int_end));
   cout << "or_test = " << i << endl;
   i = or_test(c, reinterpret_cast< BOOLEAN_FN >(odd), 
                  reinterpret_cast< END_FN >(int_end));
   cout << "or_test = " << i << endl;

   i = and_test(b, reinterpret_cast< BOOLEAN_FN >(even),
                      reinterpret_cast< END_FN >(int_end));
   cout << "and_test = " << i << endl;
   i = and_test(c, reinterpret_cast< BOOLEAN_FN >(odd), 
                  reinterpret_cast< END_FN >(int_end));
   cout << "and_test = " << i << endl;
   return 0;
}

