///////    Treating arbitrary data types    ///////
#include <iostream>
using std::cout;  using std::endl;

typedef bool (* END_FN)(void *, int);

arblen(void *any,  END_FN isEnd)
{   int len=0;
    while ( ! isEnd(any,len) ) len++;
    return len;
}

bool int_end(int *a, int i)
{   return( a[i] == -1 );
}

bool str_end(char *a, int i)
{   return( a[i] == '\0' );
}

int main()
{    char a[]="abcdefg";
     int b[]={0,1,2,3,4,-1};
     int i;
     void * foo;
     i = arblen(a, reinterpret_cast< END_FN >(str_end) );   // length 7 
     cout << "length of string = " << i << endl;
     i = arblen(b, reinterpret_cast< END_FN >(int_end) );   // length 5 
     cout << "length of int array = " << i << endl;
     return 0;
}
