///////    intsort.C    ///////
// applying arbitrary quick sort
#include <iostream>
#include "arbqsort.h"
using std::cout;  using std::endl;

int cmp_bigger(int x[], int i, int j)
{  return ( x[i] - x[j] ); }

int cmp_smaller(int x[], int i, int j)
{  return ( x[j] - x[i] ); }

void intswitch(int *a, int i, int j)
{     int s;
      s = a[i];
      a[i] = a[j];
      a[j] = s;
}

int main()
{   int a[] = {5,3,-1, 9 , 22, 99};
    int d = sizeof(a)/sizeof(int);
    quicksort(a,0,d-1, reinterpret_cast< CMP_FN >(cmp_bigger), 
              reinterpret_cast< SWAP_FN >(intswitch));
    for (int i=0; i<d; i++) cout << a[i] << " ";
    cout <<  endl;
    quicksort(a,0,d-1, reinterpret_cast< CMP_FN >(cmp_smaller), 
              reinterpret_cast< SWAP_FN >(intswitch));
    for (int i=0; i<d; i++) cout << a[i] << " ";
    cout <<  endl;
    return 0;
}
