#ifndef __Poly_SEEN__
#define  __Poly_SEEN__
///////    Poly.h    ///////
#include <iostream>

class Poly
{  public:
     Poly() { pol = NULL; }                 // default constructor
     Poly(const int *p, int terms);         // constructor
     Poly operator+(const Poly& q) const;   // poly addition
     Poly operator-(const Poly& q) const;   // poly subtraction
     Poly operator*(const Poly& q) const;   // poly multiplication
     unsigned int deg() const               // degree
     { return(pol[0] > 0 ? pol[0] : 0); }
     void display() const;                  // display host object
     /*  other members  */
   private:
     int length() const;   // length of pol
     int  *pol;
};
#endif
