///////    SortKey.C    ///////
#include <iostream>
#include <string>
#include "SortKey.h"

string SortKey::key(const string& s) const
{   int i = position;           // key token position
    if ( i == 0 ) return s;
    int i0=0, i1=0;             // start and end indices
    while ( i-- > 0 )           // skipping positions
    {   if ( i1 == string::npos )
           return string();
        i0 = s.find_first_not_of(delim, i1);
        if ( i0 == string::npos )
           return string();
        i1 = s.find_first_of(delim, i0);
    }
    if ( i1 == string::npos )
         i1 = s.length();          // length of s
    return string(s, i0, i1-i0);   // key found
}

int SortKey::lineCompare
(const string& a, const string& b) const
{   if (position == 0) return a.compare(b);
    return key(a).compare(key(b));
}
