#include <iostream>
#include <vector>
using std::vector;

class Foo
{ public:
    explicit Foo(int i=0) : val(i) {}
    Foo(const Foo& f)
    {   cout << "copy foo" << endl;
        val=f.val;
    }
    ~Foo() { cout << "~FOO" << endl; }
  private:
    int val;
};

int main()
{   vector<Foo> v;
    v.reserve(16);     // reserve enough capacity 
                       // to minimize vector growing cost
    for (int i=0; i < 9; i++)
    {    v.push_back(Foo(i+11));
         cout << "size=" << v.size() << endl;
         cout << "capacity=" << v.capacity() << endl;
    }
    v.erase(v.begin()+2);
    cout << v.size() << endl;
    return 0;
}
