///////    tstAList.C    ///////
#include <iostream>
#include <string>
#include "ArbList.h"
using std::cout; using std::endl;
using std::string;

// linked list of strings via
//       generic ArbList class

void strDisplay(string* str)
{    cout << *str;   }

bool strEq(string* a, string* b)
{   return( *a == *b); }

int main()
{    char* s[] = {"Zero", "Ten", "Twenty", 
                  "Thirty", "Forty", "Fifty"};
     string a[] = {string(s[0]),string(s[1]), string(s[2]),
                   string(s[3]), string(s[4]), string(s[5])}; 
     
     ArbList slist( a + 1, reinterpret_cast< ArbList::EQ_FN >(strEq),
            reinterpret_cast< ArbList::DISP_FN >(strDisplay) );

     slist.putOn( a + 3 );
     slist.putOn( a + 5 );
     slist.display(); cout << endl;

     slist.putOn( a );
     slist.putOn( a + 2 );
     slist.append( a + 4 );
     slist.display(); cout << endl;

     slist.remove( a + 4 );
     slist.remove( a );
     slist.display(); cout << endl;

     slist.shorten(3);
     slist.display(); cout << endl;
     slist.shorten(1);
     slist.display(); cout << endl;
}
