#ifndef CalcEng_SEEN__
#define CalcEng_SEEN__
///////    CalcEng.h    ///////

class CalcEng
{   public:
        CalcEng();                 // constructor
        void operation(char c);    // perform operation
        void operand(double in) ;  // enter operand
        char opcode() const        // returns current opcode
        {  return op;  }
        double output() const      // returns current argument
        { return( argcnt==2 ? (arg) : ans ); }
    private:
        void compute();            // mostly performs ans = ans op arg
        void allclear();
        double ans, arg;
        char op;                   // operation code
        int argcnt;                // argument count
};
#endif
