#ifndef __Poly_SEEN__
#define  __Poly_SEEN__
///////    Poly.h    ///////
//  Using dense representation

class Poly
{  public:
     Poly() { pol = 0; }                    // default constructor
     Poly(const int *p, int terms);         // constructor
     Poly operator+(const Poly& q) const;   // poly addition
     Poly operator-(const Poly& q) const;   // poly subtraction
     Poly operator*(const Poly& q) const;   // poly multiplication
     unsigned int deg() const               // degree
     {   return *pol;  }  
     void display() const;                  // display host object
     /*  other members  */
   private:
     static void s_to_d(int* buf, const int *p);
     int  *pol;
};
#endif
