///////    testTokenizer.C    ///////
#include <iostream>
#include "Tokenizer.h"
using std::cout; using std::endl;


void testToken1()
{    string t("    name John Doe   age 19   ");
     Tokenizer tk(t, " ");
     while ( tk.moreToken() )
     {   cout << tk.tokenCount() << "=";
         cout << tk.nextToken() << endl;
     }
}


void testToken()
{    string t("name=John+Doe");
     Tokenizer tk(t, "=");
     while ( tk.moreToken() )
     {   cout << tk.tokenCount() << "=";
         cout << tk.nextToken() << endl;
     }
}

void testDelToken()
{    string t("Test:of:;delimiters:;:also:as:tokens.;:");
     string del(":;");
     Tokenizer tk(t, del, true);
     while ( tk.moreToken() )
     {   cout << tk.tokenCount() << "=";
         cout << tk.nextToken() << endl;
     }
}

int main()
{  testToken1();
   testToken();
   testDelToken();
   return 0;
}
