#include <iostream>
#include <fstream>
#include <ctype.h>
using std::cout; using std::cerr;
using std::endl; using std::fstream;
using std::ios;

int main(int argc, char *argv[])
{     char c;
      if ( argc != 2 )
      {  cerr << "Usage: " << argv[0] << " file" << endl;
         return 1;
      }
      fstream fio(argv[1], ios::in | ios::out);
      if ( fio.fail() )
      {   cerr << argv[0] << ':' << " Cannot open"
                          << argv[1] << endl;
          return 1;
      }
      while ((c = fio.get()) != EOF) 
          if ( isupper(c) )
          {   fio.seekg(-1, ios::cur);   // position for writing c
              fio.put(tolower(c));
          }
      fio.close();
      return 0;
}

// note could use seekp instead of seekg
