///////    Account.C    ///////
#include  "Account.h"

Account::Account(unsigned id, double amt, const string& s)
:  acct_no (id), acct_bal(amt), ss(s) { }

double Account::balance() const 
{    return acct_bal;   }

void Account::deposit(double amt)
{    acct_bal += amt;   }

bool Account::withdraw(double amt)
{    if( amt > acct_bal )
         return false;        // failure
     acct_bal -= amt;
     return true;
}
