#ifndef __PolyAssign_SEEN__
#define  __PolyAssign_SEEN__
///////    Poly.h with assignment and copy   ///////

class Poly
{  public:
     Poly() { pol = 0; }                    // default constructor
     Poly(const int *p, int terms);         // constructor
     Poly operator+(const Poly& q) const;   // poly addition
     Poly operator-(const Poly& q) const;   // poly subtraction
     Poly operator*(const Poly& q) const;   // poly multiplication
     unsigned int deg() const               // degree
     {   return *pol;  }  
     void display() const;                  // display host object
     ~Poly() { delete [] pol; }       // destructor
     Poly(const Poly& p);             // copy constructor
     Poly& operator =(const Poly& p); // assignment
     /*  other members  */
   private:
     static void s_to_d(int* buf, const int *p);
     int  *pol;
};
#endif
