#ifndef __ArbStack_SEEN__
#define  __ArbStack_SEEN__
///////    ArbStack.h    ///////

//    generic stack derived from generic list

#include <iostream>
#include "ArbList.h"

class ArbStack : private ArbList    // keyword private is optional
{  public:
     ArbStack() { }                 // default constructor
     ArbStack(Any z);               // constructor
     bool push(Any z);              // push onto top
     Any top() const;               // value on top
     bool pop();                    // pop off top
     using ArbList::isEmpty;        // make isEmpty accessible
};

inline bool ArbStack::push(Any z)
       {    return putOn(z);   }

inline ArbStack::ArbStack(Any z)
       {    putOn(z);   }

#endif
