///////    FreeChecking.h    ///////
#ifndef _FreeChecking_SEEN_
#define _FreeChecking_SEEN_
#include "Account.h"

class FreeChecking : public virtual  Account
{ public:
     FreeChecking(unsigned n, double b,  // constructor
          char* owner);
     FreeChecking() {}                   // default constructor
     void fee();                         // charge monthly fee
     bool withdraw(double amt);          // withdraw amt 
     void display(ostream& out = cout) const;
     static float getMinbal(float m) { return min_bal;  }
     static float getFee(float f) { return service_fee; }
     static void setMinbal(float m) { min_bal = m; }
     static void setFee(float f) { service_fee = f; }
     ~FreeChecking()
     {  std::cout << "FreeChecking Destructor" << std::endl; }
  private:
     static float min_bal;
     static float service_fee;
     int free;
};
#endif
