#ifndef __IOable_SEEN__
#define  __IOable_SEEN__
///////    IOable.h    ///////
// An interface for using >> and << on
//    compliant class objects

class IOable
{  public:
   // displays host object
      virtual void display(ostream& out = cout) const =0;
   // reads into host object
     virtual void read(istream& in = cin) =0; 
};

inline ostream& operator <<(ostream& out, IOable& any)
{   any.display(out);
    return out;
}

inline istream& operator >>(istream& in, IOable& any)
{    any.read(in);
     return in;
}
#endif
