///////    Fraction.C    ///////
#include <iostream.h>
#include "Number.h"

inline void Fraction::display(ostream& out) CS
{  out << num << "/" << denom; }

Number Fraction::DivInt(CS Number& i) CS  // i / *this
{   const Integer& ii = dynamic_cast< const Integer& >(i);
    return Number(ii.val * denom, num);
}

Number Fraction::AddInt(CS Number& i) CS  // i + *this
{   const Integer& ii = dynamic_cast< const Integer& >(i);
    return Number(ii.val * denom + num, denom);
}

Number Fraction::TimInt(CS Number& i) CS  // i * *this
{   const Integer& ii = dynamic_cast< const Integer& >(i);
    return Number(ii.val * num, denom);
}

Number Fraction::DivFra(CS Number& f) CS  // f / *this
{   const Fraction& ff = dynamic_cast< const Fraction& >(f);
    Number n(ff.num * denom, ff.denom * num);
    return Number(ff.num * denom, ff.denom * num);
}

Number Fraction::TimFra(CS Number& f) CS  // f * *this
{   const Fraction& ff = dynamic_cast< const Fraction& >(f);
    return Number(ff.num * num, ff.denom * denom);
}

Number Fraction::AddFra(CS Number& f) CS  // f / *this
{   const Fraction& ff = dynamic_cast< const Fraction& >(f);
    return Number(ff.num * denom + 
           ff.denom * num, ff.denom * denom);
}
