#ifndef Integer_SEEN__
#define Integer_SEEN__
///////    Integer.h    ///////
#include "Number.h"

class Integer : public Number
{    friend class Number;
     friend class Fraction;
   protected:
     Integer(int i) :val(i) {}
     Number OP *(CS Number& n) CS
     {  return Number::TimInt(n); }
     Number OP +(CS Number& n) CS
     {  return Number::AddInt(n); }
     Number OP /(CS Number& n) CS
     {  return Number::DivInt(n); }
     Number AddFra(CS Number& f) CS;
     Number TimFra(CS Number& f) CS;
     Number DivFra(CS Number& f) CS;
     Number AddInt(CS Number& i) CS;
     Number TimInt(CS Number& i) CS;
     Number DivInt(CS Number& i) CS;
     void display(ostream& out=cout) CS
     { out << val ; }
   private:
     int val;
     Number* copy() const;
};

inline Number* Integer::copy() const
       {  return (new Integer(val)); } 
#endif
