///////    DateSeq.C    ///////
#include "DateSeq.h"

const Date& DateSeq::operator[](unsigned i)
    throw(out_of_range)
{   if ( i >= len ) 
         throw( out_of_range("DateSeq: Index too large") ); 
    if ( ! sorted() ) sort();
    return *dates[i];
}

bool DateSeq::append(void* date)    // append entry at end
{   dates.push_back(reinterpret_cast<Date*>(date));
    return true;
}

void DateSeq::remove(unsigned i)    // delete entry i
    throw(out_of_range)
{   if ( i < len )
    {   for ( int j=i ; j < len ; j++ )
            dates[j] = dates[j+1];
        len--;
        return;
    }
    throw( out_of_range("DateSeq: Index too large") ); 
}
