///////    TextLineSeq.C    ///////
#include "TextLineSeq.h"

const string& TextLineSeq::operator[](unsigned i)
     throw(out_of_range) 
{    if ( i >= len ) 
         throw( out_of_range("TextLineSeq: Index too large") ); 
    if ( ! sorted() ) sort();
    return *txtobj[i];
}

// reads line into sequence
void TextLineSeq::input(istream& in)
{  txtobj.input(in); 
   sorted(false);
   len = txtobj.length();
}

bool TextLineSeq::append(void* l)    // append entry at end
{  bool ok =
   txtobj.insert(*reinterpret_cast<string*>(l),
                  txtobj.length());
   if ( ok ) { sorted(false); len++; }
   return ok;
}
