///////    testTextLineSeq.C    ///////
#include <fstream>
#include "TextLineSeq.h"
using std::cout; using std::endl;
using std::cerr;

int main(int argc, char* argv[])
{    if (argc > 3 || argc < 1)
     {   cerr << "Usage: " << argv[0] << " [ key ] file" << endl;
         abort();
     }
     int keypos=0;
     if (argc == 3)
     {    keypos=atoi(argv[1]);
          argv[1] = argv[2];
     }
     ifstream myin(argv[1]);
     if ( ! myin )  cerr << "Can not open file "
                         <<  argv[1] << endl;

     SortKey key(keypos);
     TextLineSeq seq(key);
     seq.input(myin);
     seq.output();

     cout << "Input search key:";
     string& str = *(new string());
     getline(cin, str, '\n');  // read into str
     int i = seq.index(str);
     cout << "index for " << str << " is "
          << i << endl;
     //try {  cout << seq[i] << endl;  
     //    }  catch (out_of_range& e) 
     //     {  cerr << e.what() << endl; }
     return 0;
}
