
template <typename T>
int compare(T a, T b)
{     if ( a > b ) return 1;              // using > for T
      if ( a == b ) return 0;             // using == for T
      return -1;
}

template<> 
int compare(const char* a, const char* b)
{  return strcmp(a, b);  }

template<> 
int compare(char* a, char* b)
{  return strcmp(a, b);  }

template<typename T> 
int compare(T* a, T* b)
{  if ( a == b ) return 0;
   else if ( *a > *b ) return 1;
   else return -1;
}
