///////    testHashTable.C    ///////
#include <iostream>
#include "HashTable.h"
#include "Employee.h"
using std::cout; using std::endl;


char* empId(Employee& e)     // getkey function
{  return( e.id() );    }

int main()
{  Employee a("Big Mac", 39, "023441288");
   Employee b("John Doe", 32, "083467890");
   Employee c("Jen Sun", 24, "123451282");
   Employee d("Joe Dregs", 27, "223451228");
   Employee e("Yu Hong", 28, "323452128");
   Employee f("Sam Smith", 29, "423415228");
   Employee z;

// very small hash table for testing
   HashTable<Employee> ht(empId, 1); 
   ht.put( b ); ht.put( a ); ht.put( c );
   ht.put( d ); ht.put( e ); ht.put( f );
   if ( ht.get("333415228", z) )
        cout << z << endl;
   else
        cout << "333415228 not found" << endl;

   ht.rid(empId(a));
   if ( ! ht.isOn(empId(a)) )
        cout << "023441288 not found" << endl;

   if ( ht.get("083467890", z) )
   {    cout << z << endl; }
   else
        cout << "083467890 not found" << endl;

   cout << ht.length() << "=len"<< endl;
   ht.rid(empId(d)); ht.rid(empId(e));
   cout << ht.length() << "=len"<< endl;
   return 0;
}

// Output produced

// 333415228 not found
// 023441288 not found
// John Doe  age=32  ss=083467890
// 5=len
// 3=len

