///////    Stack.C    ///////
#pragma implementation
#include "Stack.h"

template <typename T>
bool Stack<T>::top(T& z) const
{  if ( isEmpty() ) return false;   // pop failed
   z = *begin();
   return true;                     // pop succeeded
}

template <typename T>
bool Stack<T>::pop()
{  if ( isEmpty() ) return false;   // pop failed
   shorten(1);                      // stack popped
   return true;                     // pop succeeded
}

// explicit template instantiation for use in testStack.C
template class Stack<char*>;
