#ifndef Stack__SEEN
#define Stack__SEEN
///////    Stack.h    ///////
//  stack derived from list<T>
#pragma interface
#include "List.h"

template <typename T>
class Stack : private List<T>    // keyword private is optional
{  public:
     Stack() { }                 // default constructor
     Stack(T& z) { putOn(z); }   // constructor
     bool push(T& z)             // push reference z
        { return putOn(z); }
     bool top(T& z) const;       // returns false if failed
     bool pop();                 // returns false if failed
     using List<T>::isEmpty;     // make isEmpty visible
};
#endif
