#ifndef __average_SEEN__
#define  __average_SEEN__
///////    average.h    ///////
#include <typeinfo>
#include <stdexcept>

inline bool numericType(const type_info& type );
class invalidValue;

template<typename CT>
double average(const CT& ctn)
       throw( invalidValue )
{   const type_info& t = typeid(typename CT::value_type);
    if (! numericType( t ) )
         throw( invalidValue(t.name()) );
    double ave =0.0;
    double d = ctn.size();
    for ( typename CT::const_iterator itr = ctn.begin();
          itr != ctn.end();
          ++itr )
    {   ave += *itr/d;   }
    return ave;

}
inline bool numericType(const type_info& type )
{ if ( type==typeid(int) | type==typeid(int&) |
       type==typeid(short) | type==typeid(short&) |
       type==typeid(long) | type==typeid(long&) |
       type==typeid(unsigned int) | type==typeid(unsigned int&) |
       type==typeid(unsigned short) | type==typeid(unsigned short&) |
       type==typeid(unsigned long) | type==typeid(unsigned long&) |
       type==typeid(float) | type==typeid(float&) |
       type==typeid(double) | type==typeid(double&)
     )   return true;
    else   return false;
}

class invalidValue : public invalid_argument
{  public:
      explicit invalidValue (const string& s)
      : invalid_argument(s + " is not a numeric type.")
      {  }
};
#endif
