///////    testSet.C    ///////
///  This  program can be applied to other containers
///  such as multiset<string>, vector<string>
///  or even string arr[8]
#include<iostream>
#include<fstream>
#include<algorithm>
#include<string>
#include<set>
#include<iterator>
using std::cout;     using std::endl;
using std::string;   using std::set;   using std::copy;
using std::ifstream; using std::insert_iterator; 
using std::istream_iterator;

int main()
{   ifstream infile("zipcode.txt");
    if ( ! infile ) return 1;
    istream_iterator<string> in(infile);                       // (1)
    istream_iterator<string> eos;
    set<string> zip;
    insert_iterator< set<string> > i_itr(zip, zip.begin());    // (2)

    copy(in, eos, i_itr);                                      // (3)
    cout << zip.size() << " distinct zip codes read:" << endl;
    for ( set<string>::iterator it = zip.begin();
                                it != zip.end(); ++it )
        cout << *it << "  ";
    cout << endl;
    return 0;
}
