///////    vecSort.C    ///////
// Sorting intergers with vector container and generic sort
#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
using std::cout;  using std::endl;


int main()
{  int a[] = {5,3,-1, 99, 32, 98, 66};
   int d = sizeof(a)/sizeof(int);
   std::vector<int> v(a, a+d);        // creates vector of 7 ints
   std::sort(v.begin(), v.end());     // ascending order
   for (vector<int>::iterator itr=v.begin(); 
        itr != v.end(); ++itr) cout << *itr << "  ";
   cout << endl;

// decending order
   std::greater<int> fn;               // instantiate functor
   std::sort(v.begin(), v.end(), fn);  // use functor
//std::sort(v.begin(), v.end(), std::greater<int>()); // shorthand
   for (vector<int>::iterator itr=v.begin(); 
        itr != v.end(); ++itr) cout << *itr << "  ";
   cout << endl;
   return 0;
}
