///////    Html.C    ///////
#include <fstream>
#include "Html.h"
using std::ifstream;

void Html::leader(char* title)
{  if ( started ) return;
   cout << "Content-Type: text/HTML" << "\r\n\r\n"
        << version
        << "<HTML><HEAD><TITLE>"
        << title << "</TITLE>\n";
   if ( bodyOpen==NULL )
        cout << "</HEAD><BODY>\n";
   else sendFile(bodyOpen);
   started = true;
}

void Html::trailer()
{  if ( bodyClose==NULL )
        cout << "</BODY>\n";
   else 
        sendFile(bodyClose);
   cout << "</HTML>\n";
   started = false;
} 


void Html::sendFile(char* file)
{  if ( !started ) leader("No Title");
   ifstream in(file);
   unsigned char c[1];
   while ( in.read(c, 1) ) cout.write(c,1);  
}
