///////    testFormData.C    ///////
#include <iostream>
#include "FormData.h"
using std::cout; using std::endl;
using std::cin; using std::getline;

int main()
{   FormData input;
    if ( ! input ) 
    {  input.displayError();
       return 1;
    }
    cout << "METHOD = " << input.getMethod() << endl;
    cout << "CONTENT = " << input.getContent() << endl;
    cout << "key count = " << input.keyCount() << endl;
    if ( input.hasValue("name") )
         cout << input["name"] << endl;
    if ( input.hasValue("address") )
         cout << input["address"] << endl;
    if ( input.hasValue("email") )
         cout << input["email"] << endl;
    if ( input.hasValue("phone") )
         cout << input["phone"] << endl;
    return 0;
}

// setenv REQUEST_METHOD POST
// setenv CONTENT_LENGTH 94
// a.out < line



