#ifndef CALCULATOR_SEEN__
#define CALCULATOR_SEEN__
///////    Calculator.h    ///////

#include    "CalcEng.h"
#include    "CalcFace.h"

class Calculator
{ public:
     Calculator
     (  CalcEng*  e,             // plug-compatible engine
        CalcFace* f              // plug-compatible interface
     )  
     : eng(e), cf(f) { }
     virtual void on();
  protected:
     virtual void perform(int ind, char op, double number);
     virtual void treatError();
  private:
     CalcEng*   eng; // plug-compatible engine
     CalcFace*  cf;  // plug-compatible interface
};
#endif
