///////    octalDisplay.C    ///////
#include <iostream>

void octalDisplay(register int x)
{    const int DIG = 20;
     const int LOWDIGIT = 07;   // least significant octal digit mask 
     register int i = 0;
     char s[DIG];
     if (x < 0)            
     {   std::cout.put('-'); 
         x = -x;
     }
     do {  s[i++] = ((x & LOWDIGIT) + '0'); // mod performed with &
        }  while ( ( x >>= 3) > 0 );        // divide x by 8 via shift
     std::cout.put('0');
     do {  std::cout.put(s[--i]);
        }  while ( i > 0 );
}

int main()
{    octalDisplay(0);         std::cout << std::endl; 
     octalDisplay(-1);        std::cout << std::endl; 
     octalDisplay(0123456);   std::cout << std::endl; 
     octalDisplay(-0123456);  std::cout << std::endl; 
     octalDisplay(999);       std::cout << std::endl; 
     octalDisplay(-999);      std::cout << std::endl; 
     octalDisplay(2978);      std::cout << std::endl; 
     return 0;
}
