///////    readline.C    ///////
#include <iostream>

// len is the length of the array s
int readLine(char s[], int len)
{    char c = '\0';
     int i = 0;
     len --;     // leaving room at the end
     while ( i < len && std::cin.get(c) && c != '\n')
             s[i++] = c;
     if (c == '\n') s[i++] = c;
     s[i] = '\0';  // string terminator
     return i;
}

int main()
{    const int SIZE = 100;
     char line[SIZE];
     int n;
     while ((n = readLine(line, SIZE)) > 0)
         std::cout << "n = " << n << "\t line= " 
                   << line << std::endl;
     return 0;
}
