///////    strmatch.C    ///////
#include <iostream>

int stringMatch(char str[], char line[])
{   if ( str == NULL || str[0] == '\0')   // str is empty
        return -1;
    int j, k;
    for (int i = 0 ; line[i] != '\0' ; i++)
    {   if ( line[i] != str[0] )   // first chars different
            continue;              // skip rest of loop body
        // compare remaining characters
        // until first mismatch or end of string
        for ( j = i + 1, k = 1;
              line[j]==str[k] && str[k] != '\0';
              j++, k++
            ) { }
        if ( str[k] == '\0')       // end of str is reached
            return i;              // successful match
        else if (line[j] == '\0')  // end of line is reached
            return -1;             // no match possible any more
    }
    return -1;                     // failed to match
}
