///////    rectangle.C    ///////
#include <iostream>
#include "Vector2D.h"

Vector2D getVec(int i)  // input a point as vector
{    float x,y;
     std::cout << "x" << i << "= ";
     std::cin >> x;
     std::cout << "y" << i << "= ";
     std::cin >> y;
     return Vector2D(x,y);
}

int main()
{  std::cout << "Enter vertices 0,1,2,3 "
             << std::endl;
   Vector2D p[4];                           // vector array      (1)
   for ( int i = 0; i < 4; i++)             // input all four points
      p[i] = getVec(i);
   Vector2D u = p[0].difference(p[3]);      // vector difference (2)
   Vector2D v;
   for (int i = 0; i < 3; i++)              // process all sides
   {  v = p[i+1].difference(p[i]);          // vector difference (3)
      if ( ! u.isPerpendicular(v) )         // check perpendicularity
      {   std::cout << "No, not a rectangle." << std::endl;
          return 1;
      }
      u = v;
   }
   std::cout << "Yes, a rectangle." << std::endl;
   return 0;
}
