#ifndef CalcFace__SEEN
#define CalcFace__SEEN
///////    CalcFace.h    ///////
#include <iostream>
#include <string>
using std::string;  using std::cout;  
using std::cin;     using std::endl;  

// function input: returns op in c and input number if any
//     return value == OK means both op and number are obtained
//     return value == OPONLY means only op is obtained
//     return value == OFF means no more input 
// PREC is number of digits displayed

class CalcFace
{   public:
        explicit CalcFace(char* k = "+-*/=NnAaCc" )
        { keys = string(k); }
        int input(char& c, double& number);
        void showNumber(double number) const;
        enum {OK=0, OPONLY=1, OFF=2, PREC=6};
    private:
        int inchar() { return cin.get(); }
        void extractNumber(double&) const;
        void buildNumber(char c, int& i);
        int nump(char c);
        char   nbuf[PREC+2];   // buffer for input number
        string keys;           // keys recognized
};
#endif

