#ifndef __Vector2D_SEEN__
#define  __Vector2D_SEEN__
///////    Vector2D.h    ///////
#include <iostream>

class Vector2D
{ public:
     Vector2D() {}
     Vector2D(float a, float b);
     Vector2D operator-(Vector2D a);
     float inner(Vector2D a);
     int isParallel(Vector2D a);
     int nonzero()
         { return ( x != 0.0 || y != 0.0 ); }
     void display(ostream& out = cout) const;
     void read(istream& in = cin);
     /* other members not shown */
 private:
     float x, y;
};


ostream& operator <<(ostream& out, const Vector2D& v);
istream& operator >>(istream& in, Vector2D& v);
#endif
