#ifndef _Account_SEEN_
#define _Account_SEEN_
///////    Account.h    ///////
#include <string>
using std::string;

class Account                       // class name
{ public:
     Account(unsigned n, double b,  // constructor
             const string& ss); 
     Account() {}                   // default constructor
     void deposit(double amt);      // deposit amt into this account
     bool withdraw(double amt);     // withdraw amt from this account
     double balance() const;        // balance inquiry
     unsigned id() const           // get account number
     {  return acct_no;  }
     /* other public members */
  protected:
     unsigned  acct_no;             // account number
     string    ss;                  // owner ss no.
  private:
     /* other members */
     double    acct_bal;            // current balance
};
#endif
