#ifndef __FreeChecking_SEEN__
#define  __FreeChecking_SEEN__
///////    FreeChecking.h    ///////
#include "Account.h"

class FreeChecking : public Account
{ public:
     FreeChecking(unsigned n, double b,  // constructor
          const string& owner);
     FreeChecking() {}                   // default constructor
     void fee();                         // charge monthly fee
     bool withdraw(double amt);          // withdraw amt 
     static void setMinbal(float m) { min_bal = m; }
     static void setFee(float f) { service_fee = f; }
     static float getMinbal() { return min_bal; }
     static float getFee() { return service_fee; }
  private:
     static float min_bal;
     static float service_fee;
     bool free;
};
#endif
