///////    testCirbuf.C    ///////
//// testing copy constructor, destructor, and assignment operator
#include <iostream>
#include "Cirbuf.h"
using std::cout; using std::endl;

void test(Cirbuf b1)
{  Cirbuf b2, b3;                    // b2 and b2  capacity 16
   char c;
   cout << "In function test" << endl;
   b2 = b1;                          // calling operator=
   cout << (c = b2.consume());
   cout << (c = b2.consume()) << endl;
   c = b2.consume();                 // consume empty buffer
   if (c > 0 ) cout << c;
   b3 = b2;                          // another = call
   cout << "out of function test" << endl;
}   // b2 and b3 destroyed

int main()
{  Cirbuf b1(64);                       // set up b1
   b1.produce('A');
   b1.produce('B');
   b1.produce('C');
   char c = b1.consume();               // B C remain in b1
   test(b1);
   cout << "from b1 ";                  // use b1 some more
   cout << (c = b1.consume());
   cout << (c = b1.consume()) << endl;
   return 0;
}

