///////    ArbList_ac.C    ///////
#include "ArbList_ac.h"

// generic list with assignment and copy
// a friend class of ArbList

// assignment
ArbList_ac& ArbList_ac::operator =(const ArbList_ac& x)
{   operator=( static_cast< const ArbList& >(x) );  }

// assignment of ArbList
ArbList_ac& ArbList_ac::operator =(const ArbList& x)
{   if ( &x == this ) return *this;
    if ( ! isEmpty() ) free();
    copy( static_cast< const ArbList_ac& >(x) );
    return *this;
}

void ArbList_ac::copy(const ArbList_ac& x)
{   equal = x.equal;           // copy data members
    dispfn = x.dispfn;
    ArbCell* lx = x.first();
    head = NULL;               // empty list 
    while ( ! isEnd(lx) )      // copy list
    {    append(ArbList::content(lx));
         lx = ArbList::next(lx);
    }

}
