///////    gcd.C    ///////
#include "gcd.h"

inline long int ABS(long int x) { return(x < 0 ? -x : x); } 

unsigned gcd(int a, int b) throw(WrongArg)
{   if ( a==0 && b==0 )
        throw(WrongArg(string("gcd(0,0) undefined")));
     int t;
     a = ABS(a);
     b = ABS(b);
     if ( a == 0 ) return b;    // 0 is error value
     if ( b == 0 ) return a;
     while ( b > 0 )
     {   t = a % b;
         a = b;
         b = t;
     }
     return a;
}
