#ifndef SortKey_SEEN__
#define SortKey_SEEN__
///////    SortKey.h    ///////
#include <string>
using std::string;

class SortKey
{ public:
     explicit SortKey(int pos = 0, 
                      const char* dlm = "\n\t \r")
     {  delim = dlm;
        position = pos;
     }
     void setDelim(const char* s) { delim = s; }
 // compare lines
     int lineCompare(const string& a, const string& b) const;
     int keyCompare(const string& k, const string& l) const
     {  return k.compare(key(l)); }
  private:
     string delim;    // token delimiters
     int position;    // key token position
 // extract key
     string key(const string& s) const; 
};
#endif
