#ifndef TextLines_SEEN__
#define TextLines_SEEN__
///////    TextLines.h    ///////
#include <iostream>
#include <vector>
#include <string>
using std::string; using std::istream;
using std::vector;

class TextLines
{  public:
       TextLines() { line = vector<string*>(0); };
       const string* operator[](int i) const   // overloading []
       {  if ( i >= 0 && i < len ) return line[i];  abort(); }
       string*& operator[](int i)        // overloading []
       {  if ( i >= 0 && i < len ) return line[i];  abort(); }
       int length() { return len; }
       void swap(int i, int j)      // interchange lines
       {  string* tmp = line[i];
          line[i] = line[j];
          line[j] = tmp;
       }
       void input(istream& in);
       void display();
       ~TextLines();                // destructor
   private:
       int readLines(istream& in);  // input lines

       int len;               // no. of lines
       vector<string*> line;  // vector of string* 
};
#endif
