///////    Account.C    ///////
#include  <iostream>
#include  "Account.h"

Account::Account(unsigned id, double amt)
{     acct_no = id;
      acct_bal = amt;
}

double Account::balance()
{    return acct_bal;   }

void Account::deposit(double amt)
{    acct_bal += amt;   }


bool Account::withdraw(double amt)
{    if( amt > acct_bal )
         return false;              // failure
     acct_bal -= amt;
     return true;
}

bool Account::transfer(double amt, Account& target)
{    if( amt > target.acct_bal )
         return false;            // failure
     target.acct_bal -= amt;      // charge target account (a)
     acct_bal += amt;             // credit host account
     return true;                 // success
}
