#ifndef __Account_SEEN__
#define  __Account_SEEN__
///////    Account.h    ///////

class Account                       // class name
{ public:
     Account(unsigned n, double b); // constructor
     void deposit(double amt);      // deposit amt into this account
     bool withdraw(double amt);     // withdraw amt from this account
     double balance();              // balance inquiry
     bool transfer(double amt,      // transfer amt from another account
                  Account& acct);
     /* other public members */
 private:
     unsigned  acct_no;             // account number
     double    acct_bal;            // current balance
     /* other private members */
};
#endif
