///////    testArbTree.C    ///////
#include <iostream>
#include "ArbTree.h"

int main(int argc, char* argv[])
{    int a[10] = {0,1,2,3,4,5,6,7,8,9};
     InNode* in[4];
     for (int i=0, j=4; i<4; i++)
     {   in[i] = ArbTree::parent(a+i);
         if ( i > 0 )
         {   in[0]->addChild(in[i]);
             in[i]->addChild(ArbTree::leaf(a+j++));
             in[i]->addChild(ArbTree::leaf(a+j++));
         }
     }
     ArbTree* t = new ArbTree(in[0]);
     std::cout << "Tree has " << t->size() 
              << " nodes." << std::endl;
     ArbTree::Iterator s = t->begin(ArbTree::PREORDER);
     ArbTree::Iterator e = t->end(ArbTree::PREORDER);
     // Preorder traversal
     while ( s != e )
     {    void* c = (*s).getValue();
          std::cout << *(reinterpret_cast<int*>(c));
          ++s;
          if ( s != e )  std::cout << ", ";
          else std::cout << std::endl;
     }
     delete t;
     return 0;
}

