///////    Integer.C    ///////
#include "Number.h"

Number Integer::DivInt(CS Number& i) CS
{  const Integer& ii = dynamic_cast< const Integer& >(i);
   return Number(ii.val, val);
}
   
Number Integer::TimInt(CS Number& i) CS
{  const Integer& ii = dynamic_cast< const Integer& >(i);
   return Number(ii.val*val);
}

Number Integer::AddInt(CS Number& i) CS
{  const Integer& ii = dynamic_cast< const Integer& >(i);
   return Number(ii.val+val);
}

Number Integer::DivFra(CS Number& f) CS // f / *this
{  const Fraction& ff = dynamic_cast< const Fraction& >(f);
   return Number(ff.num, ff.denom * val);
}

Number Integer::AddFra(CS Number& f) CS // f + *this
{  const Fraction& ff = dynamic_cast< const Fraction& >(f);
   return Number(ff.num + 
           ff.denom * val, ff.denom);
}

Number Integer::TimFra(CS Number& f) CS // f * *this
{  const Fraction& ff = dynamic_cast< const Fraction& >(f);
   return Number(ff.num * val, ff.denom);
}

