///////    TestIO.C    ///////
#include <iostream>
#include <fstream>
#include "TextLineSeq_IO.h"
using std::cout; using std::endl;
using std::cerr; using std::string;

// tests mixing IOable with TextLineSeq

int main(int argc, char* argv[])
{    if (argc > 3 || argc < 1)
     {   cerr << "Usage: " << argv[0] 
              << " [ key ] file" << endl;
         abort();
     }
     int keypos=0;
     if (argc == 3)
     {    keypos=atoi(argv[1]);
          argv[1] = argv[2];
     }
     ifstream myin(argv[1]);
     if ( ! myin )  cerr << "Can not open file "
                         <<  argv[1] << endl;

     SortKey key(keypos);
     TextLineSeq_IO txtobj(key);
     myin >> txtobj;   // input operation
     cout << txtobj;   // output operation
     return 0;
}
