///////    objRead.C    ///////
#include <iostream>
#include <fstream>
#include <string>
#include <complex>
#include <typeinfo>
#include "Fraction.h"
using std::cout; using std::endl;
using std::ifstream;
using std::complex;

void* readNextObj(istream& in, string& type)
{   string end;
    if ( getline(in, type, '\n') )
    {   if ( type == typeid( Fraction ).name() )
        {   Fraction* f = new Fraction();
            in >> *f;
            getline(in, end, '\n');   // consume rest of line
            return f;
        }
        if ( type == typeid( complex< double > ).name() )
        {   complex< double >* c = new complex< double >();
            in >> *c;
            getline(in, end, '\n');   // consume line
            return c;
        }
    }
    return NULL;
}
        
int main()
{   ifstream in("obj.data");
    string* t = new string();
    void* obj_ptr; 
    while ( (obj_ptr= readNextObj(in, *t)) != NULL )
    {   if ( *t == typeid( Fraction ).name() )
             cout << *(reinterpret_cast
                      < Fraction* >(obj_ptr)) << endl;
        if ( *t == typeid( complex< double > ).name() )
             cout << *(reinterpret_cast
                       < complex< double >* >(obj_ptr))
                  << endl;
        delete obj_ptr;
    }
    in.close();
    return 0;
}
