///////    testVectorND.C    ///////
#include <iostream>
#include "VectorND.h"
using std::cout; using std::endl;

int main()
{   VectorND<double,3> dv1, dv2;            // VectorND objects
    for ( int i=1 ; i <= 3 ; i++ )          // assign to components
    {    dv1[i] = i/2.0;
         dv2[i] = -i/4.0;
    }
    VectorND<double,3> dv = dv1 + dv2;      // operator+
    dv.display(); cout << endl;
    double in = dv1.inner(dv2);
    cout << "inner product = " << in << endl;
    dv = 10*dv;                             // int*VectorND
    dv.display(); cout << endl;
    return 0;
}
