///////    test_bsearch.C    ///////
#include <iostream>
#include <string.h>
#include "bsearch.h"   // need template prototype
using std::cout; using std::endl;

char *getkey(char *s, unsigned int i)
{  for ( int j = 1; j < i; j++)   // skipping fields
       while ( *s++ != ' ' );     // single space delimiter
   return s;
}

int cmpLastname(char *ent, char *key)
{    char *k = getkey(ent, 3);
     return strcmp(k, key);
}

int main()
{  char *names[] = {"George M. Blum", "Ruth B. Boland",
          "Bill C. Johnson", "David P. Moses", "Debra S. Rice",
          "John A. Smith", "Paul S. Wang"};
   const int LEN = sizeof(names)/sizeof(char*);
   int j = bsearch(names, "Rice", 0, LEN-1, cmpLastname);        // (1)
   if (j >= 0 ) cout << names[j] << endl;

   j = bsearch(names, "Doe", 0, LEN-1, cmpLastname);             // (2)
   if (j < 0 ) cout << "Doe not found" << endl;
   return 0;
}
