#ifndef __Employee_SEEN__
#define  __Employee_SEEN__
///////    Employee.h    ///////
#include   <iostream>
#include   <string.h>

class Employee
{  public:
      Employee() {}
      Employee(char* n, unsigned a, char* s) 
      :   name(n), age(a), ss(s)  { }
      char * id() { return ss; }
      int operator ==(const Employee& a) const
      { return(strcmp(ss, a.ss) == 0); }
      void display(std::ostream& out = std::cout) const ;
   private:
      char*    name;        // full name
      unsigned age;
      char*    ss;          // social security number
      float    salary;
};

std::ostream& operator<<
    (std::ostream& out, const Employee& e);
std::ostream& operator<<
    (std::ostream& out, const Employee* e);
#endif
