///////    testList.C    ///////
#include <iostream>
#include "List.h"
#include "Employee.h"
// linked list of employees via
//       List template

int main()
{ Employee a[] = {
        Employee ("Big Mac", 39, "023441288"),
        Employee ("John Doe", 32, "083467890"),
        Employee ("Jen Sun", 24, "123451282"),
        Employee ("Joe Dregs", 27, "223451228"),
        Employee ("Yu Hong", 28, "323452128"),
        Employee ("Sam Smith", 29, "423415228") };

     List<Employee> weekly( a[1] );
     weekly.putOn( a[3] );
     weekly.putOn( a[5] );
     std::cout<< weekly << std::endl;

     List<Employee>::Cell* c = weekly.last();
     std::cout << c->getValue(); std::cout<<std::endl;

     weekly.putOn( a[0] );
     weekly.putOn( a[2] );
     weekly.append( a[4] );
     std::cout<< weekly << std::endl;

     weekly.remove( a[4]);
     weekly.remove( a[0] );
     std::cout<< weekly << std::endl;

     weekly.shorten(3);
     weekly.display();
     std::cout<<std::endl;
     weekly.shorten(1);
     std::cout<< weekly << std::endl;
     return 0;
}

// The output produced

// (Sam Smith  age=29  ss=423415228, Joe Dregs  age=27  ss=223451228,
//      John Doe  age=32  ss=083467890)
// Sam Smith  age=29  ss=423415228
// (Jen Sun  age=24  ss=123451282, Big Mac  age=39  ss=023441288,
//      Sam Smith  age=29  ss=423415228, Joe Dregs  age=27  ss=223451228,
//      John Doe  age=32  ss=083467890, Yu Hong  age=28  ss=323452128)
// (Jen Sun  age=24  ss=123451282, Sam Smith  age=29  ss=423415228, 
//      Joe Dregs  age=27  ss=223451228, John Doe  age=32  ss=083467890)
// (John Doe  age=32  ss=083467890)
// ()

