#include <vector>
#include <algorithm>

template<typename IT, typename OP>
bool and_test(IT first, IT last, OP pred)
{   while ( first != last)
    {   if ( ! pred(*first) ) return false;
        ++first;
    }
    return true;
}

bool positive(double d)
{   return d > 0.0;  }

int main()
{   vector<double> vd;
    vd.push_back(5.0);
    vd.push_back(10.0);
    vd.push_back(-6.0);
    vd.push_back(7.5);
    bool ok = and_test(vd.begin(), vd.end(), positive);
    cout << (ok ? "passed" : "failed")
         << " test" <<  endl;
    return 0;
}
