#include <vector>
#include <algorithm>

template <typename T>
class Sum 
{  public:
     Sum(T init=0) : ans(init) {}
     void operator() (T x)
     {  ans += x;  }
     T result() const 
     {  return ans;  }
   private:
     T ans;
};

int main()
{   Sum<double> s(0.0);
    vector<double> vd;
    vd.push_back(5.0);
    vd.push_back(-10.0);
    vd.push_back(6.0);
    vd.push_back(7.5);
    s = for_each(vd.begin(), vd.end(), s);
    double ans = s.result();
    cout << "Ans = " << ans << endl;
    return 0;
}
