#include<iostream>
#include<set>
#include<iterator>
using std::cout;     using std::endl;
using std::set; using std::insert_iterator; 

int main()
{   int primes[] = {1, 2, 3, 5, 7, 11,13,17,19,23,29};
    set<int> smallPrimes;                // ordered set of ints
    insert_iterator < set<int> > 
           i_itr(smallPrimes,            // container to insert
           smallPrimes.begin()           // initial insertion point
           ); 
    for ( int i=0; i < 6; i++)
        *i_itr = primes[i];              // insert into set

    ostream_iterator < int > o_itr(cout, " ");

    for ( set<int>::iterator it=smallPrimes.begin();
          it != smallPrimes.end(); ++it )
        o_itr = *it;

    return 0;
}
