#include<iostream>
#include<fstream>
#include<string>
#include<algorithm>
#include<set>
#include<iterator>
using std::cout;     using std::endl;
using std::string;   using std::multiset;   using std::copy;
using std::ifstream; using std::insert_iterator; 
using std::istream_iterator;

int main()
{   multiset<string> zip;
    ifstream infile("zipcode.txt");
    if ( ! infile ) return 1;
    insert_iterator< multiset<string> > i_itr(zip, zip.begin()); 
    istream_iterator<string> in(infile);
    istream_iterator<string> eos;
    copy(in, eos, i_itr);

    cout << zip.size() << " distinct zipcodes read:" << endl;

    for ( multiset<string>::iterator it=zip.begin();
          it != zip.end(); ++it )
        cout << *it << endl;
    return 0;
}
