#ifndef __Html_SEEN__
#define  __Html_SEEN__
///////    Html.h    ///////
#include <iostream>
using std::cout;

class Html
{ public:
     Html(char* f1=NULL, char* f2=NULL)
     : bodyOpen(f1), bodyClose(f2),
       version("<!DOCTYPE HTML PUBLIC " 
                 "\"-//W3C//DTD HTML 3.2 //EN\">\n")
     { started = false; }
     void leader(char* title);
     void trailer();
     void send(char *s)
     {    if ( ! started ) leader("No Title");
          cout << s;
     }
     void sendFile(char* file);

     char* version;
  private:
     bool started;
     char* bodyOpen;
     char* bodyClose;
};
#endif
