#ifndef CalcWindow_SEEN__
#define CalcWindow_SEEN__
///////    CalcWindow.h    ///////
#include "CursesWindow.h"

class CalcWindow : protected CursesWindow
{ public:
      CalcWindow(int digits, CursesWindow* parent = &std_win);
      ~CalcWindow();
      void showOp(char c);          // shows given op code
      void showStr(char* str);      // shows given string
      void clearLcd();              // clears LCD window
      using CursesWindow::Getch;    // reads input char: char Getch()
  private:
      int x0, x1;
      void lcd(int i, char* str);
      void init();
      void cleanUp();
};
#endif
