///////    Calculator.C    ///////
#include    "Calculator.h"

void Calculator::on()
{     char op;
      double number;
      cf->showNumber(eng->output());

      // top-level cycle
      int ind;
      while ( (ind = cf->input(op, number, ! *eng))
                  != CalcFace::OFF )
      {  perform(ind, op, number);
      }
}


void Calculator::perform(int ind, char op, double number)
{     if ( ind == CalcFace::OK )
           eng->operand( number );
      eng->operate( op );
      number = ( op == 'c' || op == 'C' )
               ? 0 : eng->output();
      if ( ! *eng )  treatError();
      else
      {    op = eng->opcode();
           if ( op == '=' )
               cf->showOp(' ');
           else
               cf->showOp(op);
           cf->showNumber(number);
      }
}

void Calculator::treatError()
{    cf->showError();
}
