#ifndef LcdFace_SEEN
#define LcdFace_SEEN
///////    LcdFace.h    ///////
#include    "CalcFace.h"
#include    "CalcWindow.h"

class LcdFace : public CalcFace
{   public:
        LcdFace( const int digs,               // calculator precision
                 const char* k                 // operation keys recognized
                );
        void showNumber(double number) const;  // virtual
        void showError()  const                // virtual
        {   cw->showOp('E');    }
        void showStr(char* str) const          // virtual
        {   cw->showStr(str);  }
        void showOp(char op) const             // virtual
        {   cw->showOp(op);  }
        ~LcdFace();
    protected:
        CalcWindow*   cw;
        void buildNumber(char c, int& i);      // virtual
        int inchar() const { return cw->Getch(); }
};
#endif
