#ifndef NewEng__SEEN
#define NewEng__SEEN
///////    NewEng.h    ///////
#include "CalcEng.h"

class NewEng : public CalcEng
{   public:
        NewEng() : CalcEng(), cnst(0.0), m(0.0) { }
        void operate(char c); 
        static const char* keys;
    protected:
        void allclear();
        virtual int  pre_oper(char c);
        virtual void post_oper(char c);
        double m;      // memory register
        double cnst;   // constant register
};
#endif
