///////     NList.C    ///////
//  nested list objects
#include <iostream>
#include "NList.h"

void NList::display(NItem* p)
{   std::cout << "(";
    while ( p )
    {    if ( p->l_c == NItem::CHAR )
            std::cout << p->ch;
         else
            p->lis.display();
         if ( p = p->next ) std::cout << " ";
    }
    std::cout << ")";
}

int NList::depth()
{   int d=0, t=0;
    for ( NItem* p = head; p != NULL; p=p->next )
    {   if ( p->l_c != NItem::CHAR )
        {  t = p->lis.depth();
           if ( t > d ) d = t;
        }
    }
    return d+1;
}

bool NList::putOn(char c)
{  NItem* tmp = new NItem(c,head);
      if ( tmp )
      {  head = tmp;
         return true;
      }
      else return false; // failed
}


// insert after entry e
bool NList::insert(char c, NItem* e)
{     NItem* tmp = new NItem(c,e->next);
      if ( tmp )
      {  e->next = tmp;
         return true;
      }
      else return false; // failed
}

bool NList::insert(NList& nl, NItem* e)
{     NItem* tmp = new NItem(nl, e->next);
      if ( tmp )
      {  e->next = tmp;
         return true;
      }
      else return false; // failed
}

NItem* NList::last()
{     NItem* p = head;
      while( p && p->next ) p =  p->next; 
      return p;
}

bool NList::append(char c)
{  return insert(c, last());  }

bool NList::append(NList& nl)
{  return insert(nl, last());  }

bool NList::putOn(NList& nl)
{  NItem* tmp = new NItem(nl, head);
      if ( tmp )
      {  head = tmp;
         return true;
      }
      else return false; // failed
}
